﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace NETDeob.Core.Engine
{
    public static class Logger
    {
        public static void Log(String message, UInt32 level)
        {
            switch (level)
            {
                case 0: // Default Verbosity
                    Console.WriteLine(message);
                    break;

                default: // Higher Verbosity
                    if (Settings.Verbosity >= level)
                        Console.WriteLine(message);
                    break;
            }
        }

        public static void Addition(String message, UInt32 level)
        {
            switch (level)
            {
                case 0: // Default Verbosity
                    Console.Write(message);
                    break;

                default: // Higher Verbosity
                    if (Settings.Verbosity >= level)
                        Console.Write(message);
                    break;
            }
        }

        public static void Exception(String message, UInt32 level)
        {
            switch (level)
            {
                case 0: // Default Verbosity
                    Console.Write(String.Concat("\n", "Exception:", message, "\n"));
                    break;

                default: // Higher Verbosity
                    if (Settings.Verbosity >= level)
                        Console.Write(String.Concat("\n", "Exception:", message, "\n"));
                    break;
            }
        }
    }
}
