﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Text.RegularExpressions;
using NETDeob.Core.Deobfuscators;

namespace NETDeob.Core.Identification.Obfuscators.Confuser
{
    public class Confuser17 : IProtection
    {
        public ProtectionType Type
        {
            get { return ProtectionType.Obfuscator; }
        }

        public String Name
        {
            get { return "Confuser 1.7"; }
        }

        public Version Version
        {
            get { return new Version("1.7.0.0"); }
        }

        public List<IRoutine> Routines
        {
            get
            {
                return new List<IRoutine>
                {
                    new Deobfuscators.Confuser._1_7.Resource_Decrypter(),
                    new Deobfuscators.Confuser._1_7.Anti_Debug(),
                    new Deobfuscators.Confuser._1_7.Cleaner()
                };
            }
        }

        public Boolean Identify(String target)
        {
            var pattern = new Regex("Confuser v[0-9].[0-9].[0-9].[0-9]");
            var match = pattern.Match(File.ReadAllText(target));

            return match.Success && match.Value == "Confuser v1.7.0.0";
        }
    }
}
